{******************************************************************************************}
{ "Hundir la Flota", recreacion del clasico juego de tablero de guerra maritima.           }
{ Copyright (C) 2002  Gorka Surez Garca                                                  }
{                                                                                          }
{ Graficos.pas is part of "Hundir la Flota".                                               }
{                                                                                          }
{ "Hundir la Flota" is free software; you can redistribute it and/or                       }
{ modify it under the terms of the GNU General Public License                              }
{ as published by the Free Software Foundation; either version 2                           }
{ of the License, or (at your option) any later version.                                   }
{                                                                                          }
{ "Hundir la Flota" is distributed in the hope that it will be useful,                     }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of                           }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            }
{ GNU General Public License for more details.                                             }
{                                                                                          }
{ You should have received a copy of the GNU General Public License                        }
{ along with "Hundir la Flota"; if not, write to the Free Software                         }
{ Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              }
{******************************************************************************************}

{**************************************************************************}
{ Graficos.pas                                                             }
{ Autor: Gorka Suarez Garcia                                               }
{ Fecha: 05-02-02                                                          }
{**************************************************************************}
Unit Graficos;
Interface {Parte publica}
   Uses Crt, Graflib;

   Procedure InitPantallaJuego; {Inicializa la pantalla}
   Procedure Vencedor; {Pantalla que se muestra cuando se vence a la
                        maquina}
   Procedure Perdedor; {Pantalla que se muestra cuando se pierde contra la
                        maquina}
   Function Otramas (N : Byte) : Char; {Pregunta si quieres jugar otra
                                        partida mas}
   Procedure CambioTurno (N : Byte); {Pantalla que se muestra cuando se
                                      cambia de turno}
   Procedure Vencedor2 (N : Byte); {Pantalla que se muestra cuando alguien
                                    vence en el modo de 2 jugadores}

{**************************************************************************}

Implementation {Parte privada}

{**************************************************************************}
{----------------------- Funciones y procedimientos -----------------------}
{**************************************************************************}

   Procedure InitPantallaJuego;
   Var
      Col, Col2, i : Byte;
      n : String;
   Begin
      BorrarPantalla;

      Col  := Color(Blanco, Negro);
      Col2 := Color(CyanClaro, Negro);

      {Titulo del juego a los lados}
      PintarTexto('H', Col, 3, 8);  PintarTexto('H', Col, 78, 8); {3,7 78,7}
      PintarTexto('U', Col, 3, 10); PintarTexto('U', Col, 78, 10);
      PintarTexto('N', Col, 3, 12); PintarTexto('N', Col, 78, 12);
      PintarTexto('D', Col, 3, 14); PintarTexto('D', Col, 78, 14);
      PintarTexto('I', Col, 3, 16); PintarTexto('I', Col, 78, 16);
      PintarTexto('R', Col, 3, 18); PintarTexto('R', Col, 78, 18);

      PintarTexto('L', Col, 3, 21); PintarTexto('L', Col, 78, 21);
      PintarTexto('A', Col, 3, 23); PintarTexto('A', Col, 78, 23);

      PintarTexto('F', Col, 3, 26); PintarTexto('F', Col, 78, 26);
      PintarTexto('L', Col, 3, 28); PintarTexto('L', Col, 78, 28);
      PintarTexto('O', Col, 3, 30); PintarTexto('O', Col, 78, 30);
      PintarTexto('T', Col, 3, 32); PintarTexto('T', Col, 78, 32);
      PintarTexto('A', Col, 3, 34); PintarTexto('A', Col, 78, 34);


      Col := Color(VerdeClaro, Negro);


      {Tableros}
      PintarTexto('Tablero de Barcos', Col2, 8, 3);
      PintarTexto('', Col, 7, 6);
      PintarLineaH2('', Col, 8, 6, 37);
      PintarTexto('', Col, 38, 6);
      PintarLineaV2('', Col, 7, 7, 36);
      PintarLineaV2('', Col, 38, 7, 36);
      PintarTexto('', Col, 7, 37);
      PintarLineaH2('', Col, 8, 37, 37);
      PintarTexto('', Col, 38, 37);
      For i := 1 To 10 Do
       Begin
         Str(i, n);
         PintarTexto(n, Col2, (6 + 3 * i), 5);
         PintarTexto(Chr(64 + i), Col2, 6, (5 + 3 * i));
       End;

      PintarTexto('Tablero de Disparos', Col2, 44, 3);
      PintarTexto('', Col, 43, 6);
      PintarLineaH2('', Col, 44, 6, 73);
      PintarTexto('', Col, 74, 6);
      PintarLineaV2('', Col, 43, 7, 36);
      PintarLineaV2('', Col, 74, 7, 36);
      PintarTexto('', Col, 43, 37);
      PintarLineaH2('', Col, 44, 37, 73);
      PintarTexto('', Col, 74, 37);
      For i := 1 To 10 Do
       Begin
         Str(i, n);
         PintarTexto(n, Col2, (42 + 3 * i), 5);
         PintarTexto(Chr(64 + i), Col2, 42, (5 + 3 * i));
       End;


      {Jugador x}
      PintarTexto(' Jugador   ', Col2, 8, 40);
      PintarTexto('', Col, 7, 40);
      PintarLineaH2('', Col, 19, 40, 25);
      PintarTexto('', Col, 26, 40);
      PintarLineaV2('', Col, 7, 41, 45);
      PintarLineaV2('', Col, 26, 41, 45);
      PintarTexto('', Col, 7, 46);
      PintarLineaH2('', Col, 8, 46, 25);
      PintarTexto('', Col, 26, 46); {12.44}
      PintarTexto('Disparos:', Color(Verde, Negro), 12, 44);


      {Leyenda}
      PintarTexto(' Leyenda ', Col2, 64, 40);
      PintarTexto('', Col, 63, 40);
      PintarPunto2('', Col, 73, 40);
      PintarTexto('', Col, 74, 40);
      PintarLineaV2('', Col, 63, 41, 47);
      PintarLineaV2('', Col, 74, 41, 47);
      PintarTexto('', Col, 63, 48);
      PintarLineaH2('', Col, 64, 48, 73);
      PintarTexto('', Col, 74, 48);

      Col2 := Color(Blanco, Negro);
      PintarTexto(CBLANCO, Color(Azul, Negro), 65, 42);
      PintarTexto('Agua', Col2, 67, 42);
      PintarTexto(CBLANCO, Color(GrisOscuro, Negro), 65, 44);
      PintarTexto('Barco', Col2, 67, 44);
      PintarTexto(CBLANCO, Color(RojoClaro, Negro), 65, 46);
      PintarTexto('Tocado', Col2, 67, 46);

   End;

{**************************************************************************}

   Procedure Vencedor;
   Begin
      CambiarColor(Color(Amarillo, Negro));
      ClrScr;
      CambiarColor(Color(Amarillo, Azul));
      GotoXY(19, 22); Write('*****************************************');
      GotoXY(19, 23); Write('*                                       *');
      GotoXY(19, 24); Write('*   Jugador, has vencido a la Maquina   *');
      GotoXY(19, 25); Write('*                                       *');
      GotoXY(19, 26); Write('*****************************************');

      GotoXY(1, 50);
      ReadKey;
   End;

{**************************************************************************}

   Procedure Perdedor;
   Begin
      CambiarColor(Color(Amarillo, Negro));
      ClrScr;
      CambiarColor(Color(Amarillo, Azul));
      GotoXY(15, 22); Write('**************************************************');
      GotoXY(15, 23); Write('*                                                *');
      GotoXY(15, 24); Write('*   Jugador, has sido derrotado por la Maquina   *');
      GotoXY(15, 25); Write('*                                                *');
      GotoXY(15, 26); Write('**************************************************');

      GotoXY(1, 50);
      ReadKey;
   End;

{**************************************************************************}

   Function Otramas (N : Byte) : Char;
   Var
      Respuesta : Char;
   Begin
      CambiarColor(Color(Amarillo, Negro));
      ClrScr;
      GotoXY(20, 19); Write('****************************************');
      GotoXY(20, 20); Write('*                                      *');
      If N = 1 Then
       Begin
         GotoXY(20, 21); Write('*   Quieres jugar otra partida mas?   *')
       End
      Else
       Begin
         GotoXY(20, 21); Write('*   Quieren jugar otra partida mas?   *');
       End;
      GotoXY(20, 22); Write('*                                      *');
      GotoXY(20, 23); Write('****************************************');

      GotoXY(20, 25); Write('   **********              **********   ');
      GotoXY(20, 26); Write('   *        *              *        *   ');
      GotoXY(20, 27); Write('   *   Si   *              *   No   *   ');
      GotoXY(20, 28); Write('   *        *              *        *   ');
      GotoXY(20, 29); Write('   **********              **********   ');

      Repeat
         GotoXY(1, 50);
         Respuesta := Upcase(ReadKey);
      Until Respuesta In ['S', 'N'];

      Otramas := Respuesta;
   End;

{**************************************************************************}

   Procedure CambioTurno (N : Byte);
   Begin
      CambiarColor(Color(Amarillo, Negro));
      ClrScr;
      CambiarColor(Color(Amarillo, Azul));
      GotoXY(13, 22); Write('******************************************************');
      GotoXY(13, 23); Write('*                                                    *');
      If N = 1 Then
       Begin
         GotoXY(13, 24); Write('*   Jugador 1, por favor deje el turno a Jugador 2   *');
         GotoXY(13, 25); Write('*    Jugador 2, pulse una tecla cuando este listo    *');
         PintarTexto('2', Color(CyanClaro, Negro), 17, 40);
       End
      Else
       Begin
         GotoXY(13, 24); Write('*   Jugador 2, por favor deje el turno a Jugador 1   *');
         GotoXY(13, 25); Write('*    Jugador 1, pulse una tecla cuando este listo    *');
         PintarTexto('1', Color(CyanClaro, Negro), 17, 40);
       End;
      GotoXY(13, 26); Write('*                                                    *');
      GotoXY(13, 27); Write('******************************************************');

      GotoXY(1, 50);
      ReadKey;
   End;

{**************************************************************************}

   Procedure Vencedor2 (N : Byte);
   Begin
      CambiarColor(Color(Amarillo, Negro));
      ClrScr;
      CambiarColor(Color(Amarillo, Azul));
      GotoXY(19, 22); Write('******************************************');
      GotoXY(19, 23); Write('*                                        *');
      If N = 1 Then
       Begin
         GotoXY(19, 24); Write('*   Jugador 1, has vencido a Jugador 2   *')
       End
      Else
       Begin
         GotoXY(19, 24); Write('*   Jugador 2, has vencido a Jugador 1   *');
       End;
      GotoXY(19, 25); Write('*                                        *');
      GotoXY(19, 26); Write('******************************************');

      GotoXY(1, 50);
      ReadKey;
   End;

{**************************************************************************}

End.

{**************************************************************************}
{                         Fin de la unidad Graficos                        }
{**************************************************************************}