{******************************************************************************************}
{ "Hundir la Flota", recreacion del clasico juego de tablero de guerra maritima.           }
{ Copyright (C) 2002  Gorka Surez Garca                                                  }
{                                                                                          }
{ Menulib.pas is part of "Hundir la Flota".                                                }
{                                                                                          }
{ "Hundir la Flota" is free software; you can redistribute it and/or                       }
{ modify it under the terms of the GNU General Public License                              }
{ as published by the Free Software Foundation; either version 2                           }
{ of the License, or (at your option) any later version.                                   }
{                                                                                          }
{ "Hundir la Flota" is distributed in the hope that it will be useful,                     }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of                           }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            }
{ GNU General Public License for more details.                                             }
{                                                                                          }
{ You should have received a copy of the GNU General Public License                        }
{ along with "Hundir la Flota"; if not, write to the Free Software                         }
{ Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              }
{******************************************************************************************}

{**************************************************************************}
{ Menulib.pas                                                              }
{ Autor: Gorka Suarez Garcia                                               }
{ Fecha: 04-02-02                                                          }
{**************************************************************************}
Unit Menulib;
Interface {Parte publica}
   Uses Crt, Graflib, Sistema, Puntos, Juego;

   Procedure Menu;

{**************************************************************************}

Implementation {Parte privada}
{----- Constantes -----}
   Const
      OPCNADA  = 0;  {Indica que no esta seleccionada ninguna opcion}
      OPC1JUG  = 1;  {Indica que se ha seleccionado la opcion de 1 Jugador}
      OPC2JUG  = 2;  {Indica que se ha seleccionado la opcion de 2
                      Jugadores}
      OPCPUNT  = 3;  {Indica que se ha seleccionado la opcion de Ver
                      Puntuaciones}
      OPCAYUDA = 4;  {Indica que se ha seleccionado la opcion de Ayuda}
      OPCCREDI = 5;  {Indica que se ha seleccionado la opcion de Creditos}
      OPCSALIR = 10; {Indica que se ha seleccionado la opcion de Salir}
      OPCFIN   = 11; {Indica que hay que salir del juego}

      TIEMPO  = 2000; {Tiempo del delay en el menu}

{**************************************************************************}
{----------------------- Funciones y procedimientos -----------------------}
{**************************************************************************}

   {Rutina para gestionar la animacion del Menu}
   Procedure AnimacionMenu;
   Var
      p, p2, p3 : TPunto;
      f, c : Byte;
   Begin
      p.Car := '*';
      p.Col := Color(RojoClaro, Negro);
      p2.Car := ' ';
      p2.Col := Color(RojoClaro, Negro);

      DarPunto(3, 3, p3);
      If p3.Car = '*' Then
       Begin
         c := 3; {H 78}
         While (c < 78) Do
          Begin
            PintarPunto(p2, c, 3);
            PintarPunto(p, c, 48);
            PintarPunto(p, c + 1, 3);
            PintarPunto(p2, c + 1, 48);
            c := c + 2;
          End;

         f := 4; {V 47}
         While (f < 47) Do
          Begin
            PintarPunto(p, 3, f);
            PintarPunto(p2, 78, f);
            PintarPunto(p2, 3, f + 1);
            PintarPunto(p, 78, f + 1);
            f := f + 2;
          End;
       End
      Else
       Begin
         c := 3; {H 78}
         While (c < 78) Do
          Begin
            PintarPunto(p, c, 3);
            PintarPunto(p2, c, 48);
            PintarPunto(p2, c + 1, 3);
            PintarPunto(p, c + 1, 48);
            c := c + 2;
          End;

         f := 4; {V 47}
         While (f < 47) Do
          Begin
            PintarPunto(p2, 3, f);
            PintarPunto(p, 78, f);
            PintarPunto(p, 3, f + 1);
            PintarPunto(p2, 78, f + 1);
            f := f + 2;
          End;
       End;
   End;

{**************************************************************************}

   {Inicializador del menu}
   Procedure InitMenu (Opcion : Byte);
   Var
       p : TPunto;
   Begin
      BorrarPantalla;
      AnimacionMenu;

      {Dibujo del misil de la URSS}
      p.Car := CBLANCO;
      p.Col := Color(GrisOscuro, Rojo);
      PintarLineaV(p, 7, 24, 25);
      PintarLineaV(p, 9, 24, 25);
      PintarLineaV(p, 11, 24, 25);
      PintarLineaV(p, 9, 32, 33);
      PintarRectangulo(p, 8, 26, 10, 31);
      p.Col := Color(Amarillo, Rojo);
      PintarTexto('U', p.Col, 9, 27);
      PintarTexto('R', p.Col, 9, 28);
      PintarTexto('S', p.Col, 9, 29);
      PintarTexto('S', p.Col, 9, 30);

      {Dibujo del barco de USA}
      p.Car := ' ';
      p.Col := Color(Azul, AzulClaro);
      PintarLineaH(p, 17, 38, 18);
      p.Col := Color(Azul, GrisClaro);
      PintarLineaH(p, 11, 38, 16);
      PintarLineaH(p, 11, 39, 18);
      PintarLineaH(p, 11, 40, 18);
      p.Car := CBLANCO;
      p.Col := Color(GrisOscuro, Azul);
      PintarLineaH(p, 5, 41, 25);
      PintarLineaH(p, 5, 42, 24);
      PintarLineaH(p, 6, 43, 23);
      PintarLineaH(p, 6, 44, 22);
      PintarLineaH(p, 7, 45, 21);
      PintarLineaH(p, 7, 46, 20);
      p.Col := Color(Blanco, Azul);
      PintarTexto('USA', p.Col, 7, 42);

      {Dibujo del barco de la URSS}
      p.Car := ' ';
      p.Col := Color(RojoClaro, AzulClaro);
      PintarLineaH(p, 63, 35, 64);
      p.Col := Color(RojoClaro, GrisClaro);
      PintarLineaH(p, 65, 35, 70);
      PintarLineaH(p, 63, 36, 70);
      PintarLineaH(p, 63, 37, 70);
      p.Car := CBLANCO;
      p.Col := Color(GrisOscuro, Rojo);
      PintarLineaH(p, 56, 38, 76);
      PintarLineaH(p, 57, 39, 76);
      PintarLineaH(p, 58, 40, 75);
      PintarLineaH(p, 59, 41, 75);
      PintarLineaH(p, 60, 42, 74);
      PintarLineaH(p, 61, 43, 74);
      p.Col := Color(Amarillo, Rojo);
      PintarTexto('URSS', p.Col, 71, 39);

      {Dibujo del titulo del juego}
      p.Car := '*';
      p.Col := Color(Marron, Azul);
      PintarLineaH(p, 31, 6, 50);
      PintarLineaV(p, 31, 7, 10);
      PintarLineaV(p, 50, 7, 10);
      PintarLineaH(p, 31, 11, 50);
      p.Car := ' ';
      p.Col := Color(Amarillo, Azul);
      PintarRectangulo(p, 32, 7, 49, 10);
      PintarTexto('Hundir la Flota.', p.Col, 33, 8);
      PintarTexto('================', p.Col, 33, 9);


      {Dibujo del menu}
      p.Car := '*';
      p.Col := Color(GrisClaro, Negro);
      PintarLineaH(p, 26, 14, 55);
      PintarLineaV(p, 26, 15, 32);
      PintarLineaV(p, 55, 15, 32);
      PintarLineaH(p, 26, 33, 55);
      p.Car := ' ';
      p.Col := Color(GrisClaro, Verde);
      PintarRectangulo(p, 27, 15, 54, 32);

      p.Col := Color(GrisClaro, Azul);
      If Opcion = OPC1JUG Then
         PintarTexto(' 1 Jugador  ', Color(Amarillo, Azul), 35, 17)
      Else
         PintarTexto(' 1 Jugador  ', p.Col, 35, 17);

      If Opcion = OPC2JUG Then
         PintarTexto(' 2 Jugadores  ', Color(Amarillo, Azul), 34, 19)
      Else
         PintarTexto(' 2 Jugadores  ', p.Col, 34, 19);

      If Opcion = OPCPUNT Then
         PintarTexto(' Puntuaciones ', Color(Amarillo, Azul), 34, 21)
      Else
         PintarTexto(' Puntuaciones ', p.Col, 34, 21);

      If Opcion = OPCAYUDA Then
         PintarTexto(' Ayuda  ', Color(Amarillo, Azul), 37, 23)
      Else
         PintarTexto(' Ayuda  ', p.Col, 37, 23);

      If Opcion = OPCCREDI Then
         PintarTexto(' Creditos ', Color(Amarillo, Azul), 36, 25)
      Else
         PintarTexto(' Creditos ', p.Col, 36, 25);

      If Opcion = OPCSALIR Then
         PintarTexto(' Salir  ', Color(Amarillo, Azul), 37, 30)
      Else
         PintarTexto(' Salir  ', p.Col, 37, 30);


      {Made by me :) }
      PintarTexto('Hecho por Gorka Suarez Garcia', Color(Verde, Negro), 48, 46);
   End;

{**************************************************************************}

   {Rutina para establecer lo que pasa cuando se pulsa la Flecha hacia
    arriba}
   Procedure FlechaArriba (var Opcion : Byte);
   Begin
      Case Opcion Of
         OPCNADA:
            Opcion := OPCSALIR;
         OPC1JUG:
          Begin
            PintarTexto(' 1 Jugador  ', Color(GrisClaro, Azul), 35, 17);
            Opcion := OPCSALIR;
          End;
         OPC2JUG:
          Begin
            PintarTexto(' 2 Jugadores  ', Color(GrisClaro, Azul), 34, 19);
            Opcion := OPC1JUG;
          End;
         OPCPUNT:
          Begin
            PintarTexto(' Puntuaciones ', Color(GrisClaro, Azul), 34, 21);
            Opcion := OPC2JUG;
          End;
         OPCAYUDA:
          Begin
            PintarTexto(' Ayuda  ', Color(GrisClaro, Azul), 37, 23);
            Opcion := OPCPUNT;
          End;
         OPCCREDI:
          Begin
            PintarTexto(' Creditos ', Color(GrisClaro, Azul), 36, 25);
            Opcion := OPCAYUDA;
          End;
         OPCSALIR:
          Begin
            PintarTexto(' Salir  ', Color(GrisClaro, Azul), 37, 30);
            Opcion := OPCCREDI;
          End;
      End;

      Case Opcion Of
         OPC1JUG:  PintarTexto(' 1 Jugador  ', Color(Amarillo, Azul), 35, 17);
         OPC2JUG:  PintarTexto(' 2 Jugadores  ', Color(Amarillo, Azul), 34, 19);
         OPCPUNT:  PintarTexto(' Puntuaciones ', Color(Amarillo, Azul), 34, 21);
         OPCAYUDA: PintarTexto(' Ayuda  ', Color(Amarillo, Azul), 37, 23);
         OPCCREDI: PintarTexto(' Creditos ', Color(Amarillo, Azul), 36, 25);
         OPCSALIR: PintarTexto(' Salir  ', Color(Amarillo, Azul), 37, 30);
      End;
   End;

{**************************************************************************}

   {Rutina para establecer lo que pasa cuando se pulsa la Flecha hacia
    abajo}
   Procedure FlechaAbajo (var Opcion : Byte);
   Begin
      Case Opcion Of
         OPCNADA:
            Opcion := OPC1JUG;
         OPC1JUG:
          Begin
            PintarTexto(' 1 Jugador  ', Color(GrisClaro, Azul), 35, 17);
            Opcion := OPC2JUG;
          End;
         OPC2JUG:
          Begin
            PintarTexto(' 2 Jugadores  ', Color(GrisClaro, Azul), 34, 19);
            Opcion := OPCPUNT;
          End;
         OPCPUNT:
          Begin
            PintarTexto(' Puntuaciones ', Color(GrisClaro, Azul), 34, 21);
            Opcion := OPCAYUDA;
          End;
         OPCAYUDA:
          Begin
            PintarTexto(' Ayuda  ', Color(GrisClaro, Azul), 37, 23);
            Opcion := OPCCREDI;
          End;
         OPCCREDI:
          Begin
            PintarTexto(' Creditos ', Color(GrisClaro, Azul), 36, 25);
            Opcion := OPCSALIR;
          End;
         OPCSALIR:
          Begin
            PintarTexto(' Salir  ', Color(GrisClaro, Azul), 37, 30);
            Opcion := OPC1JUG;
          End;
      End;

      Case Opcion Of
         OPC1JUG:  PintarTexto(' 1 Jugador  ', Color(Amarillo, Azul), 35, 17);
         OPC2JUG:  PintarTexto(' 2 Jugadores  ', Color(Amarillo, Azul), 34, 19);
         OPCPUNT:  PintarTexto(' Puntuaciones ', Color(Amarillo, Azul), 34, 21);
         OPCAYUDA: PintarTexto(' Ayuda  ', Color(Amarillo, Azul), 37, 23);
         OPCCREDI: PintarTexto(' Creditos ', Color(Amarillo, Azul), 36, 25);
         OPCSALIR: PintarTexto(' Salir  ', Color(Amarillo, Azul), 37, 30);
      End;
   End;

{**************************************************************************}

   {Muestra la Ayuda del juego}
   Procedure Ayuda;
   Begin
      CambiarColor(Color(AzulClaro, Negro));
      ClrScr;

      GotoXY(24, 2); Write('********************************');
      GotoXY(24, 3); Write('*                              *');
      GotoXY(24, 4); Write('*   Ayuda de Hundir la Flota   *');
      GotoXY(24, 5); Write('*                              *');
      GotoXY(24, 6); Write('********************************');

      GotoXY(1, 9);
      Writeln('      Este es un juego de dos jugadores, que primordialmente consiste en');
      Writeln('   ver quien es el primero es destruir la flota del otro, algo asi como una');
      Writeln('   batalla naval en toda regla.');
      Writeln; {12}
      Writeln('      Cada jugador tendra dos tableros, de 10 filas (de la A a la J), por 10');
      Writeln('   columnas (de la 1 a la 10). El de la izquierda contendra los barcos del');
      Writeln('   jugador, asi como tambien donde ha disparado su oponente. Y en el derecho');
      Writeln('   contendra los diparos que el jugador haya efectuado, y los barcos tocados');
      Writeln('   o hundidos del oponente.');
      Writeln; {18}
      Writeln('      Hay cuatro tipos de barcos por jugador:');
      Writeln; {20}
      Writeln('            - Porta-aviones: Ocupan cuatro casillas y solo se tiene uno.');
      Writeln('            - Cruceros:      Ocupan tres casillas y solo se tienen dos.');
      Writeln('            - Fragatas:      Ocupan dos casillas y solo se tienen tres.');
      Writeln('            - Lanchas:       Ocupan una casillas y solo se tienen cuatro.');
      Writeln; {25}
      Writeln('      Los barcos se pueden colocar en horizontal o vertical, pero nunca en');
      Writeln('   diagonal. Y tampoco se puede poner ningun barco en una casilla contigua a');
      Writeln('   la de otro barco, es decir, los barcos no se pueden tocar entre si.');
      Writeln; {29}
      Writeln('      En cada turno el jugador podra efectuar tres disparos. Para efectuar');
      Writeln('   cada disparo, hay que indicar las coordenadas donde se desea efectuar el');
      Writeln('   disparo. Estas coordenadas seran indicadas con la letra de la de la fila');
      Writeln('   y el numero de la columna. Dependiendo de donde se haya dado, se emitira');
      Writeln('   uno de los siguientes mensajes:');
      Writeln; {35}
      Writeln('      -> Tiro al agua');
      Writeln('      -> Tocado');
      Writeln('      -> Hundido');
      Writeln; {39}
      Writeln('      El final se producira cuando uno de los dos jugadores haya acabado con');
      Writeln('   con todos los barcos de su respectivo oponente.');
      Writeln; {42}
      Writeln; {43}
      Writeln('   Espero que disfrutes jugando tanto como yo disfrute haciendo el juego ;)');
      Writeln; {45}
      Writeln('   Un saludo');
      Writeln('   Gorka Suarez Garcia');

      GotoXY(1, 50);
      ReadKey;
   End;

{**************************************************************************}

   {Muestra los Creditos del juego}
   Procedure Creditos;
   Begin
      CambiarColor(Color(Verde, Negro));
      ClrScr;
      GotoXY(22, 2);  Write('***********************************');
      GotoXY(22, 3);  Write('*                                 *');
      GotoXY(22, 4);  Write('*   Hundir la Flota version 1.0   *');
      GotoXY(22, 5);  Write('*                                 *');
      GotoXY(22, 6);  Write('***********************************');

      GotoXY(22, 8);  Write('Produccion:   Gorka Suarez Garcia');
      GotoXY(22, 9);  Write('Programacion: Gorka Suarez Garcia');
      GotoXY(22, 10); Write('Graficos:     Gorka Suarez Garcia');
      GotoXY(22, 11); Write('Sonido:       En futuras versiones ;)');

      GotoXY(22, 13); Write('Testeo:       Gorka Suarez Garcia');

      GotoXY(1, 42);
      Writeln(' NOTA: El autor, no se hace responsable de los daos, que este juego pueda');
      Writeln('       producir sobre el ordenador en el que se ejecute; ni de los daos');
      Writeln('       psicologicos que pueda producir sobre ciertas personas, que ya de por');
      Writeln('       si esten majaras; ni del dao al medio-ambiente que se produce en la');
      Writeln('       central electrica que da electricidad al ordenador en el que se esta');
      Writeln('       ejecutando el juego; ni del dao, que se pueda haber producido en el');
      Writeln('       sistema respiratorio, por la frase anterior carente de comas.');

      GotoXY(1, 50);
      ReadKey;
   End;

{**************************************************************************}

   {Sirve para pedir la confirmacion de si realmente quiere el usuario
    salir}
   Function Salir : Byte;
   Var
      Respuesta : Char;
   Begin
      CambiarColor(Color(Amarillo, Negro));
      ClrScr;
      GotoXY(12, 19); Write('********************************************************');
      GotoXY(12, 20); Write('*                                                      *');
      GotoXY(12, 21); Write('*   Estas seguro de que quieres salir del programa?   *');
      GotoXY(12, 22); Write('*                                                      *');
      GotoXY(12, 23); Write('********************************************************');

      GotoXY(12, 25); Write('          **********                **********          ');
      GotoXY(12, 26); Write('          *        *                *        *          ');
      GotoXY(12, 27); Write('          *   Si   *                *   No   *          ');
      GotoXY(12, 28); Write('          *        *                *        *          ');
      GotoXY(12, 29); Write('          **********                **********          ');

      Repeat
         GotoXY(1, 50);
         Respuesta := Upcase(ReadKey);
      Until Respuesta In ['S', 'N'];

      If Respuesta = 'S' Then
       Begin
         CambiarColor(Color(GrisClaro, Negro));
         ClrScr;
         Salir := OPCFIN;
         Writeln('Gracias por jugar a Hundir la Flota. Que pase un buen dia ;)');
         Writeln('Gorka Suarez Garcia (c) 2002');
       End
      Else If Respuesta = 'N' Then
         Salir := OPCSALIR;
   End;

{**************************************************************************}

   {Rutina para establecer lo que pasa cuando se pulsa Enter}
   Procedure Enter (var Opcion : Byte);
   Begin
      Case Opcion Of
         OPC1JUG:
          Begin
            UnJugador;
            InitMenu(OPC1JUG);
          End;
         OPC2JUG:
          Begin
            DosJugadores;
            InitMenu(OPC2JUG);
          End;
         OPCPUNT: VerPuntuaciones;
         OPCAYUDA: Ayuda;
         OPCCREDI: Creditos;
         OPCSALIR: Opcion := Salir;
      End;

      If (Opcion <> OPCFIN) And (Opcion <> OPCNADA) Then
         ActualizarPantalla;
   End;

{**************************************************************************}

   {Procedimiento para gestionar el menu}
   Procedure Menu;
   Var
      Opcion, Tecla : Byte;
      Ani : Boolean;
   Begin
      IniciarModo8050;
      Opcion := OPCNADA;
      InitMenu(Opcion);
      Ani := True;

      Repeat
         ActualizarPantalla;
         If Ani Then
          Begin
            AnimacionMenu;
            Ani := False;
          End
         Else
            Ani := True;
         Delay(TIEMPO);

         If KeyPressed Then
            Tecla := MeterTecla
         Else
            Tecla := 0;

         Case Tecla Of
            TFLECHA_AR: FlechaArriba(Opcion);
            TFLECHA_AB: FlechaAbajo(Opcion);
            TENTER:     Enter(Opcion);
         End;
      Until Opcion = OPCFIN;

      QuitarModo8050;
   End;

{**************************************************************************}

End.

{**************************************************************************}
{                         Fin de la unidad Menulib                         }
{**************************************************************************}